#include "systemc.h"

class Module: public sc_module {

public:
  SC_HAS_PROCESS(Module);

  Module(sc_module_name mn):
    sc_module(mn)
  {
    SC_THREAD(thread1);
    SC_THREAD(thread2);
    SC_THREAD(thread3);
  }

  int x;

  void thread1()
  {
    wait(1, SC_FS);
    wait(2, SC_FS);
  }

  void thread2()
  {
    wait(1, SC_FS);

    if(true) {
      wait(2, SC_FS);
    } else {

      wait(3, SC_FS);
    }

    wait(4, SC_FS);
  }

  void thread3()
  {
    wait(1, SC_FS);

    if(true) {
      wait(3, SC_FS);
    } else {

      wait(2, SC_FS);
    }

    wait(4, SC_FS);
  }
};

class Top: public sc_module {
public:

  Top(sc_module_name mn):
    sc_module(mn),
    m1("m1")
  { }

  Module m1;
};

int sc_main(int argc, char **argv)
{
  Top t("top");
  sc_start();

  return 0;
}
