#include "systemc.h"

class SequentialStatements: public sc_module {
public:
//  int x, y, z;
//  sc_event e;
  bool test, test1;

  SC_HAS_PROCESS(SequentialStatements);

  void sequential_if_else()
  {
    wait();
    int aa = 0;
    if(aa == 1)
    {
      int bb;
      wait();
      int cc;
    }
    else
    {
      int dd;
      wait();
      int ee;
    }
    if(aa == 2)
    {
      int ff;
      wait();
      int gg;
    }
    else
    {
      int hh;
      wait();
      int ii;
    }
    if(aa == 3)
    {
      int jj;
      wait();
      int kk;
    }
    else
    {
      int ll;
      wait();
      int mm;
    }
    wait();
    int nn;
  }

  void sequential_if_else_while()
  {

    int aa = 0;
    if(aa == 1)
    {
      int bb;
      wait();
      int cc;
    }
    else
    {
      int dd;
      wait();
      int ee;
    }

    int ff = 0;
    while(ff < 2) {

      int gg;
      wait();
      int hh;
      if(ff > 3) {
        int ii;
        break;
        int jj;
      }

      int kk;
      wait();
      int ll;

      if(ff > 4) {
        int mm;
        continue;
        int nn;
      }

      int oo;
      wait();
      int pp;

      if(ff > 5) {
        int qq;
        wait();
        int rr;
      }

      int ss;
      wait();
      int tt;
    }

    int uu;
    wait();
    int vv;
  }

  void sequential_if_else_for()
  {

    int aa = 0;
    if(aa == 1)
    {
      int bb;
      wait();
      int cc;
    }
    else
    {
      int dd;
      wait();
      int ee;
    }

    for(int ff = 0; ff<2; ff++) {

      int gg;
      wait();
      int hh;
      if(ff > 3) {
        int ii;
        break;
        int jj;
      }

      int kk;
      wait();
      int ll;

      if(ff > 4) {
        int mm;
        continue;
        int nn;
      }

      int oo;
      wait();
      int pp;

      if(ff > 5) {
        int qq;
        wait();
        int rr;
      }

      int ss;
      wait();
      int tt;
    }

    int uu;
    wait();
    int vv;
  }

  void sequential_if_else_do_while()
  {

    int aa = 0;
    if(aa == 1)
    {
      int bb;
      wait();
      int cc;
    }
    else
    {
      int dd;
      wait();
      int ee;
    }

    int ff = 0;

    do {
      int gg;
      wait();
      int hh;
      if(ff > 3) {
        int ii;
        break;
        int jj;
      }

      int kk;
      wait();
      int ll;

      if(ff > 4) {
        int mm;
        continue;
        int nn;
      }

      int oo;
      wait();
      int pp;

      if(ff > 5) {
        int qq;
        wait();
        int rr;
      }

      int ss;
      wait();
      int tt;
    }
    while(ff < 2);

    int uu;
    wait();
    int vv;
  }

  void sequential_double_analysis()
  {
    int aa = 3;
    if(aa > 4) {
      int bb;
      wait();
      int cc;
    } else {
      int dd;
      wait();
      int ee;
    }

    if(aa > 5) {
      int ff;
      wait();
      int gg;
    } else {
      int hh;
      wait();
      int ii;
    }

    if(aa > 6) {
      int jj;
      wait();
      int kk;
    } else {
      int ll;
      wait();
      int mm;
    }

    int nn;
    wait();
    int oo;
  }

  SequentialStatements(sc_module_name mn): sc_module(mn)
  {
    SC_THREAD(sequential_if_else);
    SC_THREAD(sequential_if_else_while);
    SC_THREAD(sequential_if_else_for);
    SC_THREAD(sequential_if_else_do_while);
    SC_THREAD(sequential_double_analysis);
  }
};

#ifndef RISC_ALL_SEGMENT_TESTS
int sc_main(int argc, char **argv)
{
  SequentialStatements mm("mm");

  sc_start();
  return 0;
}
#endif

/* ex: set softtabstop=2 tabstop=2 shiftwidth=2 expandtab: */
